(import (rnrs (6)))
((lambda (fd-in fd-out)
   (define freq (make-vector 256 0))
   (letrec ((loop (lambda ()
                    (define char (get-u8 fd-in))
                    (if (not (eof-object? char))
                      (begin
                        (vector-set!
                          freq
                          char
                          (+ 1 (vector-ref freq char)))
                        (loop))))))
     (loop))
   (letrec ((loop (lambda (i)
                    (if (< i (vector-length freq))
                      (begin
                        (vector-set! freq i (cons i (vector-ref freq i)))
                        (loop (+ i 1)))))))
     (loop 0))
   (vector-sort!
     (lambda (sa ba) (> (cdr sa) (cdr ba)))
     freq)
   (define total
     (letrec ((loop (lambda (i c)
                      (if (< i (vector-length freq))
                        (loop (+ i 1) (+ c (cdr (vector-ref freq i))))
                        c))))
       (loop 0 0)))
   (if (> total 0)
     (letrec ((loop (lambda (i)
                      (if (< i (vector-length freq))
                        ((lambda ()
                           (define elem (vector-ref freq i))
                           (vector-set!
                             freq
                             i
                             (cons (car elem)
                                   (exact->inexact (/ (cdr elem) total))))
                           (loop (+ i 1))))))))
       (loop 0)))
   (put-string
     fd-out
     "\t(struct model) {\n\t\t.items = {\n")
   (letrec ((loop (lambda (i)
                    (if (< i (vector-length freq))
                      ((lambda ()
                         (define char (car (vector-ref freq i)))
                         (define ratio (cdr (vector-ref freq i)))
                         (put-string
                           fd-out
                           (string-append
                             "\t\t\t(struct char_freq) { .who = "
                             (if (and (<= 32 char) (> 127 char))
                               (let ((char (integer->char char)))
                                 (string-append
                                   "'"
                                   (if (or (eq? #\' char) (eq? #\\ char))
                                     "\\"
                                     "")
                                   (make-string 1 char)
                                   "'"))
                               (number->string char))
                             ", .when = "
                             (number->string ratio)
                             " },\n"))
                         (loop (+ i 1))))))))
     (loop 0))
   (put-string fd-out "\t\t}\n\t},\n"))
 (standard-input-port)
 (current-output-port))
